<p:pipeline name="PBS"
	    xmlns:p="http://www.w3.org/ns/xproc"
	    xmlns:e='http://scms.org/ns/xproc/extension'
	    version="1.0">

  <p:input port="source" primary="true"/>
  <p:output port='result'/>

  <p:xslt name='dispensing-incentive'>
    <p:documentation>
      <e:label>Extract Dispensing Incentive data</e:label>
    </p:documentation>
    <p:input port="source">
      <p:pipe step="PBS" port="source"/>
    </p:input>
    <p:input port="stylesheet">
      <p:document href='../xsl/extract-dispensing-incentive.xsl'/>
    </p:input>
  </p:xslt>
  <p:store href='dispensing-incentive.txt' method='text'/>

  <p:xslt name='streamlined-authorities'>
    <p:documentation>
      <e:label>Extract Streamlined Authorities data</e:label>
    </p:documentation>
    <p:input port="source">
      <p:pipe step="PBS" port="source"/>
    </p:input>
    <p:input port="stylesheet">
      <p:document href='../xsl/extract-streamlined.xsl'/>
    </p:input>
  </p:xslt>
  <p:store href='streamlined.txt' method='text'/>

  <p:xslt name='extract-control'>
    <p:documentation>
      <e:label>Extract Control</e:label>
    </p:documentation>
    <p:input port="source">
      <p:pipe step="PBS" port="source"/>
    </p:input>
    <p:input port="stylesheet">
      <p:document href='../xsl/control.xsl'/>
    </p:input>
  </p:xslt>
  <p:store href='control.txt' method='text'/>

  <p:xslt name='extract-fees'>
    <p:documentation>
      <e:label>Extract Fees</e:label>
    </p:documentation>
    <p:input port="source">
      <p:pipe step="PBS" port="source"/>
    </p:input>
    <p:input port="stylesheet">
      <p:document href='../xsl/fees.xsl'/>
    </p:input>
  </p:xslt>
  <p:store href='fees.txt' method='text'/>

  <p:xslt name='extract-atc'>
    <p:documentation>
      <e:label>Extract ATC</e:label>
    </p:documentation>
    <p:input port="source">
      <p:pipe step="PBS" port="source"/>
    </p:input>
    <p:input port="stylesheet">
      <p:document href='../xsl/atc.xsl'/>
    </p:input>
  </p:xslt>
  <p:store href='atc.txt' method='text'/>

  <p:xslt name='extract-cautions'>
    <p:documentation>
      <e:label>Extract Cautions</e:label>
    </p:documentation>
    <p:input port="source">
      <p:pipe step="PBS" port="source"/>
    </p:input>
    <p:input port="stylesheet">
      <p:document href='../xsl/cautions.xsl'/>
    </p:input>
  </p:xslt>
  <p:store href='cautions.txt' method='text'/>

  <p:xslt name='extract-drug'>
    <p:documentation>
      <e:label>Extract Drug data</e:label>
    </p:documentation>
    <p:input port="source">
      <p:pipe step="PBS" port="source"/>
    </p:input>
    <p:input port="stylesheet">
      <p:document href='../xsl/drug.xsl'/>
    </p:input>
  </p:xslt>
  <p:store href='drug.txt' method='text'/>

  <p:xslt name='delta'>
    <p:documentation>
      <e:label>Reconcile Delta</e:label>
    </p:documentation>
    <p:input port="source">
      <p:pipe step="PBS" port="source"/>
    </p:input>
    <p:input port="stylesheet">
      <p:document href='../xsl/delta.xsl'/>
    </p:input>
  </p:xslt>

  <p:xslt name='extract-links'>
    <p:documentation>
      <e:label>Extract Links</e:label>
    </p:documentation>
    <p:input port="source">
      <p:pipe step="delta" port="result"/>
    </p:input>
    <p:input port="stylesheet">
      <p:document href='../xsl/links.xsl'/>
    </p:input>
  </p:xslt>
  <p:store href='linkextract.txt' method='text'/>

  <p:xslt name='extract-manufacturer'>
    <p:documentation>
      <e:label>Extract Manufacturers</e:label>
    </p:documentation>
    <p:input port="source">
      <p:pipe step="PBS" port="source"/>
    </p:input>
    <p:input port="stylesheet">
      <p:document href='../xsl/manufacturer.xsl'/>
    </p:input>
  </p:xslt>
  <p:store href='manufacturer.txt' method='text'/>

  <p:xslt name='extract-markups'>
    <p:documentation>
      <e:label>Extract Markups</e:label>
    </p:documentation>
    <p:input port="source">
      <p:pipe step="PBS" port="source"/>
    </p:input>
    <p:input port="stylesheet">
      <p:document href='../xsl/markups.xsl'/>
    </p:input>
  </p:xslt>
  <p:store href='markups.txt' method='text'/>

  <p:xslt name='extract-notes'>
    <p:documentation>
      <e:label>Extract Notes</e:label>
    </p:documentation>
    <p:input port="source">
      <p:pipe step="PBS" port="source"/>
    </p:input>
    <p:input port="stylesheet">
      <p:document href='../xsl/notes.xsl'/>
    </p:input>
  </p:xslt>
  <p:store href='notes.txt' method='text'/>

  <p:xslt name='extract-pharmacy'>
    <p:documentation>
      <e:label>Extract Pharmacy PBS Item Table</e:label>
    </p:documentation>
    <p:input port="source">
      <p:pipe step="delta" port="result"/>
    </p:input>
    <p:input port="stylesheet">
      <p:document href='../xsl/pharmacy.xsl'/>
    </p:input>
  </p:xslt>
  <p:store href='pharmacy.txt' method='text'/>

  <p:xslt name='extract-restrictions'>
    <p:documentation>
      <e:label>Extract Restrictions</e:label>
    </p:documentation>
    <p:input port="source">
      <p:pipe step="PBS" port="source"/>
    </p:input>
    <p:input port="stylesheet">
      <p:document href='../xsl/restrictions.xsl'/>
    </p:input>
  </p:xslt>
  <p:store href='restrictions.txt' method='text'/>
</p:pipeline>

