<xsl:stylesheet version='1.0'
  xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
  xmlns:terms="http://purl.org/dc/terms/"
  xmlns:xlink="http://www.w3.org/1999/xlink"
  xmlns:db="http://docbook.org/ns/docbook"
  xmlns:pbs="http://schema.pbs.gov.au"
  xmlns:group="http://schema.pbs.gov.au/Group/Type#"
  xmlns:xs="http://www.w3.org/2001/XMLSchema"
  xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
  xmlns:skos='http://www.w3.org/2004/02/skos/core#'>

  <xsl:import href="common.xsl"/>

  <db:article>
    <db:info>
      <db:title>Extract Prescriber Type</db:title>

      <db:copyright>
        <db:year>2013</db:year>
        <db:year>2012</db:year>
        <db:year>2011</db:year>
        <db:year>2010</db:year>
        <db:holder>Commonwealth of Australia</db:holder>
      </db:copyright>

      <db:legalnotice>
        <db:para>This software is copyrighted by the Commonwealth of Australia ("The Commonwealth").  The following terms apply to all files associated with the software unless explicitly disclaimed in individual files.</db:para>
        <db:para>Permission is hereby granted to use, copy, modify, distribute, and license this software and its documentation for any purpose, provided that existing copyright notices are retained in all copies and that this notice is included verbatim in any distributions. No written agreement, license, or royalty fee is required for any of the authorized uses. Modifications to this software may be copyrighted by their authors and need not follow the licensing terms described here, provided that the new terms are clearly indicated on the first page of each file where they apply.</db:para>
        <db:para>IN NO EVENT SHALL THE COMMONWEALTH OR DISTRIBUTORS BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</db:para>
        <db:para>THE COMMONWEALTH SPECIFICALLY DISCLAIM ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, AND THE COMMONWEALTH HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.</db:para>
      </db:legalnotice>

      <db:author>
        <db:personname>Steve Ball</db:personname>
        <db:email>Steve.Ball@health.gov.au</db:email>
        <db:affiliation>
          <db:orgname>Department of Health and Ageing</db:orgname>
          <db:orgdiv>PharmBiz</db:orgdiv>
        </db:affiliation>
      </db:author>

      <db:revhistory>
        <db:revision>
          <db:revnumber>1.8</db:revnumber>
          <db:date>2013-10-31</db:date>
          <db:authorinitials>SRB</db:authorinitials>
          <db:revremark>Use common template to translate characters to ASCII.</db:revremark>
        </db:revision>
        <db:revision>
          <db:revnumber>1.7.1</db:revnumber>
          <db:date>2012-08-08</db:date>
          <db:authorinitials>SRB</db:authorinitials>
          <db:revremark>Performance optimisation.</db:revremark>
        </db:revision>
        <db:revision>
          <db:revnumber>1.7</db:revnumber>
          <db:date>2012-05-29</db:date>
          <db:authorinitials>SRB</db:authorinitials>
          <db:revremark>Add support for solvent-injectable combo items.</db:revremark>
        </db:revision>
        <db:revision>
          <db:revnumber>1.6.1</db:revnumber>
          <db:date>2012-05-16</db:date>
          <db:authorinitials>SRB</db:authorinitials>
          <db:revremark>Changed program code "EX" to "EP".</db:revremark>
        </db:revision>
        <db:revision>
          <db:revnumber>1.6</db:revnumber>
          <db:date>2011-12-08</db:date>
          <db:authorinitials>SRB</db:authorinitials>
          <db:revremark>Fixed display of drug-name for ready-prepared items.</db:revremark>
        </db:revision>
        <db:revision>
          <db:revnumber>1.5</db:revnumber>
          <db:date>2011-11-24</db:date>
          <db:authorinitials>BD</db:authorinitials>
          <db:revremark>Only one row per prescribing-rule code</db:revremark>
        </db:revision>
        <db:revision>
          <db:revnumber>1.4</db:revnumber>
          <db:date>2011-10-25</db:date>
          <db:authorinitials>SRB</db:authorinitials>
          <db:revremark>Drug name only uses MP descriptor for ready-prepareds and infusibles.</db:revremark>
        </db:revision>
        <db:revision>
          <db:revnumber>1.3</db:revnumber>
          <db:date>2011-10-12</db:date>
          <db:authorinitials>DMM</db:authorinitials>
          <db:revremark>Translation of non-ASCII characters into ASCII equivalents.</db:revremark>
        </db:revision>
        <db:revision>
          <db:revnumber>1.2</db:revnumber>
          <db:date>2011-05-24</db:date>
          <db:authorinitials>SRB</db:authorinitials>
          <db:revremark>Updated to PBS XML v2.5.</db:revremark>
        </db:revision>
        <db:revision>
          <db:revnumber>1.1</db:revnumber>
          <db:date>2011-01-21</db:date>
          <db:authorinitials>SRB</db:authorinitials>
          <db:revremark>Updated to PBS XML v2.4.</db:revremark>
        </db:revision>
        <db:revision>
          <db:revnumber>1.0</db:revnumber>
          <db:date>2010-03-23</db:date>
          <db:authorinitials>SRB</db:authorinitials>
          <db:revremark>Initial version.</db:revremark>
        </db:revision>
      </db:revhistory>
    </db:info>

    <db:para>This stylesheet extracts prescriber type data from the PBS XML document.</db:para>
    <db:para>The source document is the PBS XML document, schema-valid to v2.4 (or later) of the PBS XML Schema.</db:para>
    <db:para>The result is text. Each line lists the prescriber type applicable to an item. See parameter descriptions for further details about the format of the text output.</db:para>
  </db:article>

  <xsl:output method='text'/>

  <db:param>What information to display, and the order in which to display it. Allowed values are: <db:literal>drug-name</db:literal>, <db:literal>item-code</db:literal> and <db:literal>prescriber-type</db:literal>.</db:param>
  <xsl:param name='display'>
drug-name
item-code
prescriber-type
  </xsl:param>

  <db:param>Whether to display a single prescriber type per line (multiple rows per PBS Item), or to display all prescriber types on a single line. Allowed values are: <db:literal>single</db:literal> or <db:literal>multiple</db:literal>. The value <db:literal>single</db:literal> (the default) specifies that each row will contain a single prescriber type, the value <db:literal>multiple</db:literal> specifies that each row will contain all prescriber types for an item.</db:param>
  <xsl:param name='lines' select='"single"'/>

  <db:param>What mode to operate in. Allowed values are: <db:literal>auto</db:literal>, <db:literal>full</db:literal> or <db:literal>update</db:literal>. <db:literal>full</db:literal> mode (the default) produces a full list of prescriber types. <db:literal>update</db:literal> mode compares this schedule to the previous schedule and produces a list of prescriber types that have been added or deleted. <db:literal>update</db:literal> mode requires the <db:tag>previous-schedule</db:tag> parameter to be specified. <db:literal>auto</db:literal> mode attempts to discover if the previous schedule is available; if it is then it switches to <db:literal>update</db:literal> mode, if not then <db:literal>full</db:literal> mode is used.</db:param>
  <xsl:param name='mode' select='"full"'/>

  <db:param>The URL for the previous schedule. This parameter is required for <db:literal>update</db:literal> mode, but is otherwise ignored.</db:param>
  <xsl:param name='previous-schedule'/>
  <xsl:variable name='prev' select='document($previous-schedule)'/>

  <xsl:variable name='meta-group'
    select='"http://schema.pbs.gov.au/Group#prescriber-types"'/>

  <xsl:key name='pr-by-id'
    match='pbs:prescribing-rule[not(ancestor::pbs:changes-list)]'
    use='pbs:code'/>
  <xsl:key name='ident'
    match='*'
    use='@xml:id'/>
  <xsl:key name='concept-by-id'
    match='skos:Concept'
    use='@rdf:about'/>

  <xsl:template match='/'>
    <xsl:variable name='schedule-date-year'
      select='substring(/pbs:root/pbs:info/terms:valid[1], 1, 4)'/>
    <xsl:variable name='schedule-date-month'
      select='substring(/pbs:root/pbs:info/terms:valid[1], 6, 2)'/>

    <xsl:choose>
      <xsl:when test='$mode = "auto" and
                      ($schedule-date-year = "" or
                      $schedule-date-month = "" or
                      translate($schedule-date-year, "0123456789", "") != "" or
                      translate($schedule-date-month, "0123456789", "") != "")'>
        <xsl:message terminate='yes'>auto mode cannot determine schedule date</xsl:message>
      </xsl:when>
      <xsl:when test='$mode = "auto"'>
        <xsl:variable name='previous-year'>
          <xsl:choose>
            <xsl:when test='$schedule-date-month = 1'>
              <xsl:value-of select='$schedule-date-year - 1'/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select='$schedule-date-year'/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name='previous-month'>
          <xsl:choose>
            <xsl:when test='$schedule-date-month = 1'>12</xsl:when>
            <xsl:otherwise>
              <xsl:value-of select='format-number($schedule-date-month - 1, "00")'/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
 
        <xsl:variable name='previous-schedule'
          select='concat("G2B ", $previous-year, $previous-month, "01.xml")'/>

        <xsl:variable name='prev' select='document($previous-schedule)'/>

        <xsl:choose>
          <xsl:when test='$prev'>
            <!-- switch to mode "update" -->
            <xsl:call-template name='update'>
              <xsl:with-param name='prev' select='$prev'/>
              <xsl:with-param name='mode'>update</xsl:with-param>
            </xsl:call-template>
          </xsl:when>
          <xsl:otherwise>
            <!-- switch to mode "full" -->
            <xsl:call-template name='full'>
              <xsl:with-param name='mode'>full</xsl:with-param>
            </xsl:call-template>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>

      <xsl:when test='$mode = "update"'>
        <xsl:call-template name='update'>
          <xsl:with-param name='prev' select='$prev'/>
          <xsl:with-param name='mode'>update</xsl:with-param>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name='full'>
          <xsl:with-param name='mode'>full</xsl:with-param>
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name='full'>
    <xsl:param name='prev' select='/..'/>
    <xsl:param name='mode' select='"full"'/>

    <xsl:apply-templates>
      <xsl:with-param name='other' select='$prev'/>
      <xsl:with-param name='mode' select='"full"'/>
    </xsl:apply-templates>
  </xsl:template>
  <xsl:template name='update'>
    <xsl:param name='prev' select='/..'/>
    <xsl:param name='mode' select='"update"'/>

    <xsl:if test='not($prev)'>
      <xsl:message terminate='yes'>unable to open previous month's schedule</xsl:message>
    </xsl:if>

    <xsl:text>ADDITIONS&#xa;&#xa;</xsl:text>

    <!-- First look in the current document (the current schedule).
         For each item, see if the corresponding item has the prescriber type
         in the previous schedule.
      -->

    <xsl:apply-templates>
      <xsl:with-param name='other' select='$prev'/>
      <xsl:with-param name='mode' select='"update"'/>
    </xsl:apply-templates>

    <xsl:text>&#xa;&#xa;DELETIONS&#xa;&#xa;</xsl:text>

    <!-- Now look in the previous document (last month's schedule).
         For each item, see if the corresponding item has the prescriber type
         in the current schedule.
      -->

    <xsl:apply-templates select='$prev'
      mode='deletions'>
      <xsl:with-param name='other' select='/'/>
      <xsl:with-param name='mode' select='"update"'/>
    </xsl:apply-templates>
  </xsl:template>

  <xsl:template match='pbs:prescribing-rule'
    mode='deletions'>
    <xsl:param name='other' select='/..'/>

    <xsl:call-template name='prs'>
      <xsl:with-param name='other' select='$other'/>
      <xsl:with-param name='mode' select='"update"'/>
    </xsl:call-template>
  </xsl:template>

  <db:template>
    <db:info>
      <db:title>Prescribing Rules</db:title>
    </db:info>
    <db:para>This template determines the prescriber types for a prescribing rule. In <db:literal>full</db:literal> mode, the prescriber types are displayed. In <db:literal>update</db:literal> mode, the prescriber types are compared to either the previous schedule (for additions) or current schedule (for deletions) and is only displayed if it is different in the other document.</db:para>
    <db:para>This template works for both additions and deletions. The only difference is which document is being checked for the corresponding prescribing rule. The document to compare against is given in the <db:literal>other</db:literal> parameter.</db:para>
  </db:template>
  <xsl:template match='pbs:prescribing-rule'
    name='prs'>
    <xsl:param name='other' select='/..'/>
    <xsl:param name='mode'/>

    <xsl:variable name="this" select="./pbs:code"/>
    <!-- only process the first prescribing rule of a set -->
    <xsl:if test="not(preceding-sibling::pbs:prescribing-rule/pbs:code[text() = $this/text()])">
      
      <xsl:variable name='type-list'>
      <xsl:call-template name='get-type-list'>
        <xsl:with-param name='node' select='.'/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name='type-list.norm'
      select='normalize-space($type-list)'/>

    <xsl:variable name='item-code' select='pbs:code'/>
    <xsl:variable name='other-type-list'>
      <xsl:for-each select='$other'>
        <xsl:call-template name='get-type-list'>
          <xsl:with-param name='node' select='key("pr-by-id", $item-code)'/>
        </xsl:call-template>
      </xsl:for-each>
    </xsl:variable>
    <xsl:variable name='other-type-list.norm'
      select='normalize-space($other-type-list)'/>

    <xsl:choose>
      <xsl:when test='normalize-space($type-list) = ""'/>
      <xsl:when test='$mode = "update" and
                      $type-list.norm = $other-type-list.norm'/>
      <xsl:when test='$mode = "update"'>
        <xsl:call-template name='type-update'>
          <xsl:with-param name='current' select='$type-list.norm'/>
          <xsl:with-param name='other' select='$other-type-list.norm'/>
          <xsl:with-param name='pr' select='.'/>
        </xsl:call-template>
      </xsl:when>

      <xsl:when test='$lines = "multiple"'>
        <xsl:call-template name='display-multiple'>
          <xsl:with-param name='types' select='$type-list.norm'/>
          <xsl:with-param name='pr' select='.'/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name='display'>
          <xsl:with-param name='what' select='$display'/>
          <xsl:with-param name='types' select='$type-list.norm'/>
          <xsl:with-param name='pr' select='.'/>
        </xsl:call-template>
        <xsl:text>&#xa;</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
    </xsl:if>
  </xsl:template>

  <db:template name='type-update'>
    <db:refpurpose>Display additional prescriber types</db:refpurpose>
    <db:para>Search through the given list of prescriber codes and find those that are not in the alternate list. Display each new prescriber code.</db:para>
  </db:template>
  <xsl:template name='type-update'>
    <xsl:param name='current'/>
    <xsl:param name='other'/>
    <xsl:param name='pr' select='/..'/>

    <xsl:choose>
      <xsl:when test='not($current)'/>
      <xsl:when test='contains($current, " ")'>
        <xsl:call-template name='type-update'>
          <xsl:with-param name='current' select='substring-before($current, " ")'/>
          <xsl:with-param name='other' select='$other'/>
          <xsl:with-param name='pr' select='$pr'/>
        </xsl:call-template>
        <xsl:call-template name='type-update'>
          <xsl:with-param name='current' select='substring-after($current, " ")'/>
          <xsl:with-param name='other' select='$other'/>
          <xsl:with-param name='pr' select='$pr'/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test='not(contains($other, $current))'>
        <xsl:call-template name='display'>
          <xsl:with-param name='what' select='$display'/>
          <xsl:with-param name='types' select='$current'/>
          <xsl:with-param name='pr' select='$pr'/>
        </xsl:call-template>
      </xsl:when>
    </xsl:choose>
  </xsl:template>

  <db:template name='get-type-list'>
    <db:refpurpose>Determine prescriber types</db:refpurpose>
    <db:para>Returns a space-separated list of prescriber type codes for a prescribing rule.</db:para>
  </db:template>
  <xsl:template name='get-type-list'>
    <xsl:param name='node' select='/..'/>

    <xsl:choose>
      <xsl:when test='$node/pbs:member-of-list/pbs:member-of'>
        <!-- Make sure at least one of the groups is a prescriber group -->
        <xsl:variable name='prescriber-groups'
          select='$node/pbs:member-of-list/pbs:member-of[key("ident", substring(key("ident", substring(@xlink:href, 2))/pbs:member-of-list/pbs:member-of/@xlink:href, 2))/pbs:name = $meta-group]'/>

        <xsl:choose>
          <xsl:when test='$prescriber-groups'>
            <xsl:for-each select='$prescriber-groups'>
              <xsl:value-of select='key("ident", substring(@xlink:href, 2))/pbs:name'/>
              <xsl:text> </xsl:text>
            </xsl:for-each>
          </xsl:when>
          <xsl:otherwise>
            <xsl:call-template name='infer-type'>
              <xsl:with-param name='node' select='$node'/>
            </xsl:call-template>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:otherwise>
        <!-- No group membership information has been given, so infer prescriber type from the schedule category -->
        <xsl:call-template name='infer-type'>
          <xsl:with-param name='node' select='$node'/>
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <db:template name='display-multiple'>
    <db:refpurpose>One-per-line Display</db:refpurpose>
    <db:para>This template splits a multi-valued type into separate calls to the display template, so that prescriber types are displayed one per line.</db:para>
  </db:template>
  <xsl:template name='display-multiple'>
    <xsl:param name='types'/>
    <xsl:param name='pr' select='/..'/>

    <xsl:choose>
      <xsl:when test='contains($types, " ")'>
        <xsl:call-template name='display'>
          <xsl:with-param name='what' select='$display'/>
          <xsl:with-param name='pr' select='$pr'/>
          <xsl:with-param name='types' select='substring-before($types, " ")'/>
        </xsl:call-template>
        <xsl:text>&#xa;</xsl:text>
        <xsl:call-template name='display-multiple'>
          <xsl:with-param name='pr' select='$pr'/>
          <xsl:with-param name='types' select='substring-after($types, " ")'/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name='display'>
          <xsl:with-param name='what' select='$display'/>
          <xsl:with-param name='pr' select='$pr'/>
          <xsl:with-param name='types' select='$types'/>
        </xsl:call-template>
        <xsl:text>&#xa;</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <db:template name='display'>
    <db:refpurpose>Display values</db:refpurpose>
    <db:para>This template implements a generalised mechanism for displaying values from the data.  The <db:literal>what</db:literal> parameter controls what values are included and in what order.</db:para>
  </db:template>
  <xsl:template name='display'>
    <xsl:param name='what'/>
    <xsl:param name='prefix'/>
    <xsl:param name='types'/>
    <xsl:param name='pr' select='/..'/>

    <xsl:choose>
      <xsl:when test='normalize-space($what) = ""'/>
      <xsl:when test='contains($what, "&#xa;") and
                      normalize-space(substring-before($what, "&#xa;")) = ""'>
        <xsl:call-template name='display'>
          <xsl:with-param name='what'
            select='substring-after($what, "&#xa;")'/>
          <xsl:with-param name='prefix' select='$prefix'/>
          <xsl:with-param name='pr' select='$pr'/>
          <xsl:with-param name='types' select='$types'/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test='contains($what, "&#xa;")'>
        <xsl:call-template name='display-one'>
          <xsl:with-param name='item'
            select='normalize-space(substring-before($what, "&#xa;"))'/>
          <xsl:with-param name='prefix' select='$prefix'/>
          <xsl:with-param name='pr' select='$pr'/>
          <xsl:with-param name='types' select='$types'/>
        </xsl:call-template>

        <xsl:call-template name='display'>
          <xsl:with-param name='what'
            select='substring-after($what, "&#xa;")'/>
          <xsl:with-param name='prefix' select='"&#9;"'/>
          <xsl:with-param name='pr' select='$pr'/>
          <xsl:with-param name='types' select='$types'/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name='display-one'>
          <xsl:with-param name='item'
            select='normalize-space($what)'/>
          <xsl:with-param name='prefix' select='$prefix'/>
          <xsl:with-param name='pr' select='$pr'/>
          <xsl:with-param name='types' select='$types'/>
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <db:template name='display-one'>
    <db:refpurpose>Display a value</db:refpurpose>
    <db:para>Display a single data value.</db:para>
  </db:template>
  <xsl:template name='display-one'>
    <xsl:param name='item'/>
    <xsl:param name='pr' select='/..'/>
    <xsl:param name='prefix'/>
    <xsl:param name='types'/>

    <xsl:choose>
      <xsl:when test='not($pr)'/>
      <xsl:when test='$item = ""'/>

      <xsl:when test='$item = "drug-name" and
                      $pr/pbs:ready-prepared'>
        <xsl:value-of select='$prefix'/>
        <xsl:variable name='mpp'
          select='key("ident", substring($pr/pbs:ready-prepared/pbs:mpp-reference/@xlink:href, 2))'/>
        <xsl:apply-templates select='$mpp/../db:title' mode='textonly'/>
      </xsl:when>
      <xsl:when test='$item = "drug-name" and
                      $pr/pbs:infusible'>
        <xsl:value-of select='$prefix'/>
        <xsl:variable name='mp'
          select='key("ident", substring($pr/pbs:infusible/pbs:mp-reference/@xlink:href, 2))'/>
        <xsl:apply-templates select='$mp/db:title' mode='textonly'/>
      </xsl:when>
      <xsl:when test='$item = "drug-name" and
                      ($pr/pbs:standard-formula-preparation |
                      $pr/pbs:extemporaneous-preparation |
                      $pr/pbs:drug-tariff)'>
        <xsl:value-of select='$prefix'/>
        <xsl:apply-templates select='$pr/pbs:standard-formula-preparation |
                                     $pr/pbs:extemporaneous-preparation |
                                     $pr/pbs:drug-tariff'
          mode='sfp'/>
      </xsl:when>
      <xsl:when test='$item = "drug-name" and
                      $pr/pbs:solvent-rule'>
        <xsl:variable name='injectable'
          select='key("ident", substring($pr/pbs:solvent-rule/pbs:injectable/pbs:listing-reference/@xlink:href, 2))'/>
        <xsl:value-of select='$prefix'/>
        <xsl:variable name='mpp'
          select='key("ident", substring($injectable/pbs:ready-prepared/pbs:mpp-reference/@xlink:href, 2))'/>
        <xsl:apply-templates select='$mpp/../db:title' mode='textonly'/>
      </xsl:when>
      <xsl:when test='$item = "item-code"'>
        <xsl:value-of select='$prefix'/>
        <xsl:apply-templates select='$pr/pbs:code'
          mode='textonly'/>
      </xsl:when>
      <xsl:when test='$item = "prescriber-type"'>
        <xsl:value-of select='$prefix'/>
        <xsl:call-template name='display-types'>
          <xsl:with-param name='types' select='$types'/>
        </xsl:call-template>
      </xsl:when>
    </xsl:choose>
  </xsl:template>

  <xsl:template match='pbs:standard-formula-preparation |
                       pbs:extemporaneous-preparation |
                       pbs:drug-tariff'
    mode='sfp'>
    <xsl:apply-templates select='db:title' mode='textonly'/>
    <xsl:if test='pbs:maximum-quantity'>
      <xsl:text>, </xsl:text>
      <xsl:apply-templates select='pbs:maximum-quantity' mode='sfp'/>
    </xsl:if>
  </xsl:template>
  <xsl:template match='pbs:maximum-quantity'
    mode='sfp'>
    <xsl:apply-templates mode='textonly'/>
    <xsl:apply-templates select='@unit' mode='textonly'/>
  </xsl:template>

  <!-- Only process the full schedule -->
  <xsl:template match='pbs:changes-list'/>

  <db:template name='display-types'>
    <db:refpurpose>Display Prescriber Type Code</db:refpurpose>
    <db:para>Display the code for a prescriber type.</db:para>
  </db:template>
  <xsl:template name='display-types'>
    <xsl:param name='types'/>

    <xsl:choose>
      <xsl:when test='not($types)'/>
      <xsl:when test='contains(normalize-space($types), " ")'>
        <xsl:call-template name='display-types'>
          <xsl:with-param name='types' select='substring-before(normalize-space($types), " ")'/>
        </xsl:call-template>
        <xsl:text> </xsl:text>
        <xsl:call-template name='display-types'>
          <xsl:with-param name='types' select='substring-after(normalize-space($types), " ")'/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates
          select='key("concept-by-id", $types)/skos:prefLabel'
          mode='textonly'/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match='*'>
    <xsl:param name='other' select='/..'/>
    <xsl:param name='mode'/>

    <xsl:apply-templates>
      <xsl:with-param name='other' select='$other'/>
      <xsl:with-param name='mode' select='$mode'/>
    </xsl:apply-templates>
  </xsl:template>
  <xsl:template match='*' mode='deletions'>
    <xsl:param name='other' select='/..'/>
    <xsl:param name='mode'/>

    <xsl:apply-templates>
      <xsl:with-param name='other' select='$other'/>
      <xsl:with-param name='mode' select='$mode'/>
    </xsl:apply-templates>
  </xsl:template>

  <xsl:template match='text()|@*'/>
  <xsl:template match='text()|@*' mode='deletions'/>
  
  <xsl:template name='infer-type'>
    <xsl:param name='node' select='.'/>

    <xsl:choose>
      <xsl:when test='$node/ancestor::pbs:listings-list[pbs:info/pbs:code = "GE"] |
                      $node/ancestor::pbs:listings-list[pbs:info/pbs:code = "EP"] |
                      $node/ancestor::pbs:listings-list[pbs:info/pbs:code = "SB"] |
                      $node/ancestor::pbs:listings-list[pbs:info/pbs:code = "DB"] |
                      $node/ancestor::pbs:listings-list[pbs:info/pbs:code = "PL"] |
                      $node/ancestor::pbs:listings-list[pbs:info/pbs:code = "PQ"] |
                      $node/ancestor::pbs:listings-list[pbs:info/pbs:code = "R1"] |
                      $node/ancestor::pbs:listings-list[pbs:info/pbs:code = "HS"] |
                      $node/ancestor::pbs:listings-list[pbs:info/pbs:code = "IF"] |
                      $node/ancestor::pbs:listings-list[pbs:info/pbs:code = "MD"] |
                      $node/ancestor::pbs:listings-list[pbs:info/pbs:code = "MF"] |
                      $node/ancestor::pbs:listings-list[pbs:info/pbs:code = "GH"] |
                      $node/ancestor::pbs:listings-list[pbs:info/pbs:code = "IN"] |
                      $node/ancestor::pbs:listings-list[pbs:info/pbs:code = "IP"] |
                      $node/ancestor::pbs:listings-list[pbs:info/pbs:code = "CS"] |
                      $node/ancestor::pbs:listings-list[pbs:info/pbs:code = "CT"] |
                      $node/ancestor::pbs:listings-list[pbs:info/pbs:code = "TY"] |
                      $node/ancestor::pbs:listings-list[pbs:info/pbs:code = "TZ"]'>
        <xsl:text>http://schema.pbs.gov.au/Group#medical</xsl:text>
      </xsl:when>
      <xsl:when test='$node/ancestor::pbs:listings-list[pbs:info/pbs:code = "DT"] |
                      $node/ancestor::pbs:listings-list[pbs:info/pbs:code = "DS"]'>
        <xsl:text>http://schema.pbs.gov.au/Group#dental</xsl:text>
      </xsl:when>
      <xsl:when test='$node/ancestor::pbs:listings-list[pbs:info/pbs:code = "OT"]'>
        <xsl:text>http://schema.pbs.gov.au/Group#optometrical</xsl:text>
      </xsl:when>
      <xsl:when test='$node/pbs:standard-formula-preparation'>
        <xsl:text>http://schema.pbs.gov.au/Group#medical</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:message>Item <xsl:value-of select='$node/pbs:code'/> has unknown prescriber type</xsl:message>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
</xsl:stylesheet>
